import { h } from 'snabbdom'
import { Redraw } from './interfaces';
import { bind } from './util';

export interface BoolSetting {
  name: string,
  title?: string,
  id: string,
  checked: boolean;
  disabled?: boolean;
  change(v: boolean): void;
}

export function boolSetting(o: BoolSetting, trans: Trans, redraw: Redraw) {
  const fullId = 'abset-' + o.id;
  return h('div.setting', o.title ? {
    attrs: { title: trans.noarg(o.title) }
  } : {}, [
    h('label', { attrs: { 'for': fullId } }, trans.noarg(o.name)),
    h('div.switch', [
      h('input#' + fullId + '.cmn-toggle.cmn-toggle-round', {
        attrs: {
          type: 'checkbox',
          checked: o.checked
        },
        hook: bind('change', e => o.change((e.target as HTMLInputElement).checked), redraw)
      }),
      h('label', { attrs: { 'for': fullId } })
    ])
  ]);
}
